Loading...
Searching...
No Matches
irr::scene::ISceneNodeFactory Class Referenceabstract

Interface for dynamic creation of scene nodes. More...

`#include <ISceneNodeFactory.h>`

Inheritance diagram for irr::scene::ISceneNodeFactory:

## Public Member Functions

virtual ISceneNode * | addSceneNode (const c8 *typeName, ISceneNode *parent=0)=0
| adds a scene node to the scene graph based on its type name
virtual ISceneNode * | addSceneNode (ESCENE_NODE_TYPE type, ISceneNode *parent=0)=0
| adds a scene node to the scene graph based on its type id
virtual u32 | getCreatableSceneNodeTypeCount () const =0
| returns amount of scene node types this factory is able to create
virtual ESCENE_NODE_TYPE | getCreateableSceneNodeType (u32 idx) const =0
| returns type of a createable scene node type
virtual const c8 * | getCreateableSceneNodeTypeName (ESCENE_NODE_TYPE type) const =0
| returns type name of a createable scene node type
virtual const c8 * | getCreateableSceneNodeTypeName (u32 idx) const =0
| returns type name of a createable scene node type by index
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.

## Detailed Description

Interface for dynamic creation of scene nodes.

To be able to add custom scene nodes to Irrlicht and to make it possible for the scene manager to save and load those external scene nodes, simply implement this interface and register it in you scene manager via ISceneManager::registerSceneNodeFactory. Note: When implementing your own scene node factory, don't call ISceneNodeManager::grab() to increase the reference counter of the scene node manager. This is not necessary because the scene node manager will grab() the factory anyway, and otherwise cyclic references will be created and the scene manager and all its nodes won't get deallocated.

Definition at line 27 of file ISceneNodeFactory.h.

## Member Function Documentation

## addSceneNode() [1/2]

virtual ISceneNode * irr::scene::ISceneNodeFactory::addSceneNode | ( | const c8 * | typeName,
|  | ISceneNode * | parent = 0 )

pure virtual

adds a scene node to the scene graph based on its type name

Parameters

  typeName | Type name of the scene node to add.
  parent | Parent scene node of the new node, can be null to add the scene node to the root.

Returns
  Returns pointer to the new scene node or null if not successful. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

## addSceneNode() [2/2]

virtual ISceneNode * irr::scene::ISceneNodeFactory::addSceneNode | ( | ESCENE_NODE_TYPE | type,
|  | ISceneNode * | parent = 0 )

pure virtual

adds a scene node to the scene graph based on its type id

Parameters

  type | Type of the scene node to add.
  parent | Parent scene node of the new node, can be null to add the scene node to the root.

Returns
  Returns pointer to the new scene node or null if not successful. This pointer should not be dropped. See IReferenceCounted::drop() for more information.

## getCreatableSceneNodeTypeCount()

virtual u32 irr::scene::ISceneNodeFactory::getCreatableSceneNodeTypeCount | ( |  | ) | const

pure virtual

returns amount of scene node types this factory is able to create

## getCreateableSceneNodeType()

virtual ESCENE_NODE_TYPE irr::scene::ISceneNodeFactory::getCreateableSceneNodeType | ( | u32 | idx | ) | const

pure virtual

returns type of a createable scene node type

Parameters

  idx | Index of scene node type in this factory. Must be a value between 0 and getCreatableSceneNodeTypeCount()

## getCreateableSceneNodeTypeName() [1/2]

virtual const c8 * irr::scene::ISceneNodeFactory::getCreateableSceneNodeTypeName | ( | ESCENE_NODE_TYPE | type | ) | const

pure virtual

returns type name of a createable scene node type

Parameters

  type | Type of scene node.

Returns
  : Returns name of scene node type if this factory can create the type, otherwise 0.

## getCreateableSceneNodeTypeName() [2/2]

virtual const c8 * irr::scene::ISceneNodeFactory::getCreateableSceneNodeTypeName | ( | u32 | idx | ) | const

pure virtual

returns type name of a createable scene node type by index

Parameters

  idx | Index of scene node type in this factory. Must be a value between 0 and getCreatableSceneNodeTypeCount()

The documentation for this class was generated from the following file:

- ISceneNodeFactory.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0